#include <p24FJ64GB002.h>
#include "servo.h"

extern uint16_t trim[4];
extern double phase[4];
// *****************************************************************************
#define GetSystemClock()            32000000UL
#define GetPeripheralClock()        (GetSystemClock())
#define GetInstructionClock()       (GetSystemClock() / 2)

void DelayMs(uint16_t ms) {
    unsigned char i;
    while (ms--) {
        i = 4;
        while (i--) {
            Delay10us(25);
        }
    }
}

void Delay10us(uint16_t dwCount) {
    volatile uint16_t _dcnt;

    _dcnt = dwCount * ((uint16_t) (0.00001 / (1.0 / GetInstructionClock()) / 10));
    while (_dcnt--) {
#if defined(__C32__)
        Nop();
        Nop();
        Nop();
#endif
    }
}

uint16_t ANG2VAL(uint8_t angle) {

    double val;

    val = (4800. - 1100.) / 180. * (double) angle + 1100.;
    return ((uint16_t) val);
}

void home(void) {
    OC1R = ANG2VAL(90 + trim[0]);
    OC2R = ANG2VAL(90 + trim[1]);
    OC3R = ANG2VAL(90 + trim[2]);
    OC4R = ANG2VAL(90 + trim[3]);
    phase[0] = 0.;
    phase[1] = 0.;
    phase[2] = 0.;
    phase[3] = 0.;
}
